﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private mCallBack As Object
	Private mFolder As String
	Private Const TABLE_NAME As String = "testTable"
	Private con As SQL
	
End Sub

Public Sub Initialize (CallBack As Object, Folder As String)
	mCallBack = CallBack
	mFolder = Folder
End Sub
Public Sub RunTests
	Dim s As Long = DateTime.Now
	AddRecordsTest
	Log("AddRecordsTest: " & (DateTime.Now - s))
	s = DateTime.Now
	GetAllResults
	Log("GetAllResults: " & (DateTime.Now - s))
	s = DateTime.Now
	SaveLargeFile
	Log("SaveLargeFile: " & (DateTime.Now - s))
	s = DateTime.Now
	LoadFile
	Log("LoadFile: " & (DateTime.Now - s))
End Sub

Public Sub AddRecordsTest
	File.Delete(mFolder, "test.db")
#If B4A
	con.Initialize(mFolder, "test.db", True)
#End If
#If B4I
	con.Initialize(mFolder, "test.db", True)
#End If
	con.ExecNonQuery("CREATE TABLE IF NOT EXISTS " & TABLE_NAME & CRLF & _
                "(id INTEGER PRIMARY KEY AUTOINCREMENT, firstName varchar(30), lastName varchar(30), misc TEXT )")
	Dim maxValue As Int = 999
	con.BeginTransaction
	For i = 0 To maxValue
		con.ExecNonQuery2("INSERT INTO " & TABLE_NAME & " VALUES (null, ?, ?, ?)", _
			Array ("test", "person" & i, "12345678901234567890123456789012345678901234567890"))
	Next
	con.TransactionSuccessful
#If B4A
	con.EndTransaction
#End If
End Sub

Public Sub GetAllResults
	Dim res As List
	res.Initialize
#If B4A
	Dim crsr As Cursor = con.ExecQuery("SELECT * FROM " & TABLE_NAME)
	For i = 0 To crsr.RowCount - 1
		crsr.Position = i
		res.Add(crsr.GetString2(1) & " " & crsr.GetString2(2))
	Next
#End If
#If B4I
	Dim crsr As ResultSet = con.ExecQuery("SELECT * FROM " & TABLE_NAME)
	Do While crsr.NextRow
		res.Add(crsr.GetString2(1) & " " & crsr.GetString2(2))
	Loop
#End If
	crsr.Close
	CallSub2(mCallBack, "FillList", res)
End Sub

Public Sub SaveLargeFile
	Dim maxValue As Int = 999
	Dim lines As List
	lines.Initialize
	For i = 0 To maxValue
		lines.Add("Writing line to file at index: " & i)
	Next
	File.WriteList(mFolder, "1.txt", lines)
End Sub
Public Sub LoadFile
	Dim lines As List = File.ReadList(mFolder, "1.txt")
	CallSub2(mCallBack, "FillList", lines)
End Sub



